#include <IRremote.h>
#include <LiquidCrystal.h>
#include <DHT.h>
#include <DHT_U.h>
#define Boton1 0xFF30CF  
#define Boton2 0xFF18E7  
#define Boton3 0xFF7A85  
#define Boton4 0xFF10EF  
#define Boton5 0xFF38C7  
#define Boton6 0xFF5AA5  
#define Boton7 0xFF42BD  
#define Boton8 0xFF4AB5  
#define Boton9 0xFF52AD  
#define Boton0 0xFF6897
#define EQ 0xFF9867

//varible contadora de la lista de canales
int lista=1;

//inicializar lcd y caracteres
LiquidCrystal lcd(8,9,4,3,11,7);
byte grados[] = {
  B00110,
  B01001,
  B01001,
  B00110,
  B00000,
  B00000,
  B00000,
  B00000
};
byte alien1[] = {
  B11111,
  B10101,
  B11111,
  B11111,
  B01110,
  B01010,
  B11011,
  B00000
};
byte alien2[] = {
  B11111,
  B10101,
  B11111,
  B11111,
  B01110,
  B01011,
  B11000,
  B00000
};
byte alien3[] = {
  B11111,
  B10101,
  B11111,
  B11111,
  B01110,
  B11010,
  B00011,
  B00000
};
byte onda1[] = {
  B00000,
  B00000,
  B00000,
  B00000,
  B10001,
  B01010,
  B00100,
  B00000
};
byte onda2[] = {
  B00000,
  B00100,
  B01010,
  B10001,
  B00000,
  B00000,
  B00000,
  B00000
};
byte enne[] = {
  B01110,
  B00000,
  B10110,
  B11001,
  B10001,
  B10001,
  B10001,
  B00000
};

//varibles dht
int TyH=2;
int temp;
int hum;
DHT dht (TyH,DHT11);

//varibles joys y led rgb
int x,y,sw;
int boton=13;
int ledAzul=5;
int ledRojo=10;
int ledVerde=6;
int cont=1;
int brilloA=0;
int brilloR=0;
int brilloV=0;

//varibles ir
int IRpin = 12;
IRrecv irrecv(IRpin);
decode_results codigo;

//variables hora
int useg=0;
int umin=0;
int uhora=0;
int dseg=0;
int dmin=0;
int dhora=0;
unsigned long tiempo1=0;
unsigned long tiempo2=0;
int contHora=1;

//variables fecha
int dia=1;
int mes=1;
bool undia=false;
String nmes;
int cdia;
int anno=2020;
bool unanno=false;
int cursorMes;
int contFecha=1;

//varibles cronometro
int horas = 0;
int minutos = 0;
int segundos = 0;
int decimas = 0;
unsigned long milisegundos=0;
bool crono=false;

void setup() {
  Serial.begin(9600);
  pinMode(boton,INPUT);
  pinMode(ledAzul,OUTPUT);
  pinMode(ledRojo,OUTPUT);
  pinMode(ledVerde,OUTPUT);
  lcd.begin(16,2);
  lcd.createChar(0,grados);
  lcd.createChar(1,alien1);
  lcd.createChar(2,alien2);
  lcd.createChar(3,alien3);
  lcd.createChar(4,onda1);
  lcd.createChar(5,onda2);
  lcd.createChar(6,enne);
  dht.begin();
  irrecv.enableIRIn();
  bienvenida();
}

void loop() {
  unSegundo();
  contadorReloj();
  contadorFecha();
  codigoreci();

  if(codigo.value==Boton1){
    mostrarHora(); 
  }
  if(codigo.value==Boton2){
    cambiarHora();
  }
  if(codigo.value==Boton3||codigo.value==EQ){
    cronometro();
  }
  if(codigo.value==Boton4){
    mostrarFecha();
  }
  if(codigo.value==Boton5){
    cambiarFecha();
  }
  if(codigo.value==Boton6){
    humedad();
  }
  if(codigo.value==Boton7){
    temperatura();
  }
  if(codigo.value==Boton8){
    luzLed();
    mostrarBrillo();
  }
  if(codigo.value==Boton9){
    ledLDR();
  }
  if(codigo.value==Boton0){
    listaCanales();
  }
}

void bienvenida(){
  lcd.setCursor(0,0);
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.print("BIENVENIDO");
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.setCursor(4,1);
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  delay(500);
  lcd.setCursor(0,0);
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.print("BIENVENIDO");
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.setCursor(4,1);
  lcd.write(byte(2));
  lcd.write(byte(2));
  lcd.write(byte(2));
  lcd.write(byte(2));
  lcd.write(byte(2));
  lcd.write(byte(2));
  lcd.write(byte(2));
  lcd.write(byte(2));
  delay(500);
  lcd.setCursor(0,0);
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.print("BIENVENIDO");
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.setCursor(4,1);
  lcd.write(byte(3));
  lcd.write(byte(3));
  lcd.write(byte(3));
  lcd.write(byte(3));
  lcd.write(byte(3));
  lcd.write(byte(3));
  lcd.write(byte(3));
  lcd.write(byte(3));
  delay(500);
  lcd.setCursor(0,0);
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.print("BIENVENIDO");
  lcd.write(byte(5));
  lcd.write(byte(4));
  lcd.write(byte(5));
  lcd.setCursor(4,1);
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  lcd.write(byte(1));
  delay(500);
}

void unSegundo(){
  tiempo2=(millis()/1000);
  if (tiempo1!=tiempo2){
    tiempo1=tiempo2;
    useg++;  
  }
}

void contadorReloj(){
  if(useg==10){
    useg=0;
    dseg++;  
  }
  if((dseg==6)&&(useg==0)){
    useg=0;
    dseg=0;
    umin++;
  }
  if(umin==10){
    umin=0;
    dmin++;  
  }
  if((dmin==6)&&(umin==0)){
    umin=0;
    dmin=0;
    uhora++;
  } 
  if(uhora==10){
   uhora=0;
   dhora++;
  } 
  if((dhora==2)&&(uhora==4)){
    uhora=0;
    dhora=0;
    undia=true;
  if((mes==12)&&(dia==31)){
    unanno=true;
  }
 }
}

void temperatura(){
  temp=dht.readTemperature();
  lcd.setCursor(2,0);
  lcd.print("Temperatura");
  lcd.setCursor(6,1);
  lcd.print(temp);
  lcd.write(byte(0));
  lcd.print("C");
  delay(500);
}

void humedad(){
  hum=dht.readHumidity();
  lcd.setCursor(4,0);
  lcd.print("Humedad");
  lcd.setCursor(6,1);
  lcd.print(hum);
  lcd.print(" %");
  delay(500);
}

void contadorFecha(){
  if(undia==true){
    dia++;
    undia=false;
  }
  if(dia==cdia){
    mes++;
    dia=1;
  }
  switch(mes){
    case 1://enero
      cdia=32;
      nmes="Enero";
      cursorMes=7;
      break;
    case 2://febrero
      if((anno)%4==0){
        cdia=30;
      }else{
        cdia=29;
      }
      nmes="Febrero";
      cursorMes=6;
      break;
    case 3://marzo
      cdia=32;
      nmes="Marzo";
      cursorMes=7;
      break;
    case 4://abril
      cdia=31;
      nmes="Abril";
      cursorMes=7;
      break;
    case 5://mayo
      cdia=32;
      nmes="Mayo";
      cursorMes=7;
      break;
    case 6://junio
      cdia=31;
      nmes="Junio";
      cursorMes=7;
      break;
    case 7://julio
      cdia=32;
      nmes="Julio";
      cursorMes=7;
      break;
    case 8://agosto
      cdia=32;
      nmes="Agosto";
      cursorMes=6;
      break;
    case 9://septiembre
      cdia=31;
      nmes="Septiembre";
      cursorMes=4;
      break;
    case 10://octubre
      cdia=32;
      nmes="Octubre";
      cursorMes=6;
      break;
    case 11://noviembre
      cdia=31;
      nmes="Noviembre";
      cursorMes=5;
      break;
    case 12://diciembre
      cdia=32;
      nmes="Diciembre";
      cursorMes=5;
      break;
    default:
      break;
  }
  if(mes>12){
    mes=1;
  }
  if(unanno==true){
    anno++;
    unanno=false;
  }
}

void mostrarFecha(){
  lcd.clear();
  lcd.setCursor((cursorMes-3),0);
  lcd.print(dia);
  lcd.setCursor(cursorMes,0);
  lcd.print(nmes);
  lcd.setCursor(0,1);
  lcd.print("----- ");
  lcd.print(anno);
  lcd.print(" -----");
  delay(300);
}

void mostrarHora(){
  lcd.setCursor(1,0);
  lcd.print("Reloj sin RTC");

  lcd.setCursor(4,1);
  lcd.print(dhora);
  lcd.print(uhora);
  lcd.print(":");
  lcd.print(dmin);
  lcd.print(umin);
  lcd.print(":");
  lcd.print(dseg);
  lcd.print(useg);
}

void codigoreci(){
  if (irrecv.decode(&codigo)){
    Serial.println(codigo.value, HEX);
    irrecv.resume();
    if(codigo.value==EQ)
    crono=true;
    delay(200);
    lcd.clear();  
  }
  
}

void luzLed(){
  y=analogRead(A1);
  sw=digitalRead(boton);
  if(sw==LOW){
    cont++;
    delay(300);
  }
  switch(cont){
    case 1:
      analogWrite(ledRojo,brilloR);
      if (y>=0&&y<480){
        brilloR++;
        if(brilloR>255)
        brilloR=255;
      }
      if (y>=520&&y<1023){
        brilloR--;
        if(brilloR<0)
        brilloR=0;
      }
      break;
    case 2:
      analogWrite(ledVerde,brilloV);
      if (y>=0&&y<480){
        brilloV++;
        if(brilloV>255)
        brilloV=255;
      }
      if (y>=520&&y<1023){
        brilloV--;
        if(brilloV<0)
        brilloV=0;
      }
      break;
    case 3:
      analogWrite(ledAzul,brilloA);
      if (y>=0&&y<480){
        brilloA++;
        if(brilloA>255)
        brilloA=255;
      }
      if (y>=520&&y<1023){
        brilloA--;
        if(brilloA<0)
        brilloA=0;
      }
      break;
    default:
      break;
  }
  if(cont==4)
  cont=1;
}

void mostrarBrillo(){
  lcd.clear();
  lcd.setCursor(2,0);
  lcd.print("R:");
  lcd.print(brilloR);
  lcd.setCursor(9,0);
  lcd.print("G:");
  lcd.print(brilloV);
  lcd.setCursor(2,1);
  lcd.print("B:");
  lcd.print(brilloA);
  delay(15);
}

void listaCanales(){
  lcd.clear();
  x=analogRead(A0);
  lcd.setCursor(0,0);
  lcd.print("LISTA DE CANALES");
  String canales;
  switch(lista){
    case 1:
      canales="1:Reloj";
      break;
    case 2:
      canales="2:Cambiar hora";
      break;
    case 3:
      canales="3:Cronometro";
      break;
    case 4:
      canales="4:Fecha";
      break;
    case 5:
      canales="5:Cambiar fecha";
      break;
    case 6:
      canales="6:Humedad";
      break;
    case 7:
      canales="7:Temperatura";
      break;
    case 8:
      canales="8:Led/Joystick";
      break;
    case 9:
      canales="9:Led/LDR";
      break;
    default:
      break;
  }
  if(x>=0&&x<=480){
    lista--;
    if(lista<1)
    lista=1;
  }
  if(x>=520&&x<=1023){
    lista++;
    if(lista>9)
    lista=9;
  }
  lcd.setCursor(0,1);
  lcd.print(canales);
  delay(200);
}

void ledLDR(){
  int brilloLDR;
  brilloLDR=analogRead(A2);
  if(brilloLDR<=300){
    analogWrite(ledRojo,255);
    analogWrite(ledVerde,255);
    analogWrite(ledAzul,255);
  }
  if(brilloLDR>300&&brilloLDR<=700){
    analogWrite(ledRojo,100);
    analogWrite(ledVerde,100);
    analogWrite(ledAzul,100);
  }
  if(brilloLDR>700){
    analogWrite(ledRojo,0);
    analogWrite(ledVerde,0);
    analogWrite(ledAzul,0);
  }
  lcd.setCursor(1,0);
  lcd.print("LED CONTROLADO");
  lcd.setCursor(4,1);
  lcd.print("CON LDR");
  delay(300);
}

void cronometro(){
  sw=digitalRead(boton);
  if(crono==true){
    horas = 0;
    minutos = 0;
    segundos = 0;
    decimas = 0;
    lcd.clear();
    crono=false;
  }
  
  milisegundos = millis();
  
  if(milisegundos % 100 == 0){
    decimas++;
    if(decimas == 10){
      decimas = 0;
      segundos++;
    }
    if(segundos == 60){
      segundos = 0;
      minutos++;
    }
    if(minutos == 60){
      minutos = 0;
      horas++;
    }

    lcd.setCursor(3,0);
    lcd.print("Cronometro");
    
    lcd.setCursor(2,1);
    if(horas < 10){
      lcd.print("0");
    }
    lcd.print(horas);
    lcd.print(":");
    lcd.setCursor(5,1);
    if(minutos < 10){
      lcd.print("0");
    }
    lcd.print(minutos);
    lcd.print(":");
    lcd.setCursor(8,1);
    if(segundos < 10){
      lcd.print("0");
    }
    lcd.print(segundos);
    lcd.print("(");
    lcd.setCursor(11,1);
    lcd.print(decimas);
    lcd.print(")");   
  }
    
  if(digitalRead(boton) == LOW){
    delay(200);
    while(digitalRead(boton)==HIGH);
    delay(200);
  }
}

void cambiarFecha(){
  y=analogRead(A1);
  sw=digitalRead(boton);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Cambio de fecha");
  if(sw==LOW){
    contFecha++;
    delay(200);
  }
  switch(contFecha){
    case 1:
      if (y>=0&&y<480){
        dia++;
        if(dia==cdia)
        dia=cdia-1;
      }
      if (y>=520&&y<1023){
        dia--;
        if(dia<1)
        dia=1;
      }
      lcd.setCursor(0,1);
      lcd.print("Dia: ");
      lcd.print(dia);
      break;
    case 2:
      if (y>=0&&y<480){
        mes++;
        if(mes>12)
        mes=12;
      }
      if (y>=520&&y<1023){
        mes--;
        if(mes<1)
        mes=1;
      }
      lcd.setCursor(0,1);
      lcd.print("Mes: ");
      lcd.print(nmes);
      break;
    case 3:
      if (y>=0&&y<480){
        anno++;
      }
      if (y>=520&&y<1023){
        anno--;
      }
      lcd.setCursor(0,1);
      lcd.print("A");
      lcd.write(byte(6));
      lcd.print("o: ");
      lcd.print(anno);
      break;
    default:
      break;
  }
  if(contFecha==4)
  contFecha=1;
  
  delay(250);
}

void cambiarHora(){
  y=analogRead(A1);
  sw=digitalRead(boton);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Cambio de hora");
  if(sw==LOW){
    contHora++;
    delay(200);
  }
  switch(contHora){
    case 1:
      if (y>=0&&y<480){
        umin++;
      }
      if (y>=520&&y<1023){
        umin--;        
        if((dmin!=0)&&(umin<0)){
          dmin--;
          umin=9;
        }
        if(umin<0){
          umin=0;
          dmin--;
        }
        if(dmin<0)
        dmin=0;
      }
      lcd.setCursor(0,1);
      lcd.print("Minutos: ");
      lcd.print(dmin);
      lcd.print(umin);
      break;
    case 2:
      if (y>=0&&y<480){
        uhora++;
      }
      if (y>=520&&y<1023){
        uhora--;        
        if((dhora!=0)&&(uhora<0)){
          dhora--;
          uhora=9;
        }
        if(uhora<0){
          uhora=0;
          dhora--;
        }
        if(dhora<0)
        dhora=0;
      }
      lcd.setCursor(0,1);
      lcd.print("Hora: ");
      lcd.print(dhora);
      lcd.print(uhora);
      break;
    default:
      break;
  }
  if(contHora==3)
  contHora=1;

  delay(250);
}
